
module Main where

--------------------------------------------------------------------------------

import Test.Framework
import Test.Framework.Providers.QuickCheck2
                                           
import Tests.Binary.Lazy       ( testgroup_Binary_Lazy       )
import Tests.Binary.Strict     ( testgroup_Binary_Strict     )
import Tests.Ternary.Lazy      ( testgroup_Ternary_Lazy      )
import Tests.Ternary.Strict    ( testgroup_Ternary_Strict    )
import Tests.Quaternary.Lazy   ( testgroup_Quaternary_Lazy   )
import Tests.Quaternary.Strict ( testgroup_Quaternary_Strict )


--------------------------------------------------------------------------------

main :: IO ()
main = defaultMain tests

tests :: [Test]
tests = 
  [ testgroup_Binary_Lazy
  , testgroup_Binary_Strict
  , testgroup_Ternary_Lazy
  , testgroup_Ternary_Strict
  , testgroup_Quaternary_Lazy
  , testgroup_Quaternary_Strict
  ]

--------------------------------------------------------------------------------
